

# ListThingTypes
<a name="API_ListThingTypes"></a>

Lists the existing thing types.

Requires permission to access the [ListThingTypes](https://docs.aws.amazon.com/service-authorization/latest/reference/list_awsiot.html#awsiot-actions-as-permissions) action.

## Request Syntax
<a name="API_ListThingTypes_RequestSyntax"></a>

```
GET /thing-types?maxResults=maxResults&nextToken=nextToken&thingTypeName=thingTypeName HTTP/1.1
```

## URI Request Parameters
<a name="API_ListThingTypes_RequestParameters"></a>

The request uses the following URI parameters.

 ** [maxResults](#API_ListThingTypes_RequestSyntax) **   <a name="iot-ListThingTypes-request-uri-maxResults"></a>
The maximum number of results to return in this operation.  
Valid Range: Minimum value of 1. Maximum value of 250.

 ** [nextToken](#API_ListThingTypes_RequestSyntax) **   <a name="iot-ListThingTypes-request-uri-nextToken"></a>
To retrieve the next set of results, the `nextToken` value from a previous response; otherwise **null** to receive the first set of results.

 ** [thingTypeName](#API_ListThingTypes_RequestSyntax) **   <a name="iot-ListThingTypes-request-uri-thingTypeName"></a>
The name of the thing type.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `[a-zA-Z0-9:_-]+` 

## Request Body
<a name="API_ListThingTypes_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_ListThingTypes_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "nextToken": "string",
   "thingTypes": [ 
      { 
         "thingTypeArn": "string",
         "thingTypeMetadata": { 
            "creationDate": number,
            "deprecated": boolean,
            "deprecationDate": number
         },
         "thingTypeName": "string",
         "thingTypeProperties": { 
            "mqtt5Configuration": { 
               "propagatingAttributes": [ 
                  { 
                     "connectionAttribute": "string",
                     "thingAttribute": "string",
                     "userPropertyKey": "string"
                  }
               ]
            },
            "searchableAttributes": [ "string" ],
            "thingTypeDescription": "string"
         }
      }
   ]
}
```

## Response Elements
<a name="API_ListThingTypes_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [nextToken](#API_ListThingTypes_ResponseSyntax) **   <a name="iot-ListThingTypes-response-nextToken"></a>
The token for the next set of results. Will not be returned if operation has returned all results.  
Type: String

 ** [thingTypes](#API_ListThingTypes_ResponseSyntax) **   <a name="iot-ListThingTypes-response-thingTypes"></a>
The thing types.  
Type: Array of [ThingTypeDefinition](API_ThingTypeDefinition.md) objects

## Errors
<a name="API_ListThingTypes_Errors"></a>

 ** InternalFailureException **   
An unexpected error has occurred.    
 ** message **   
The message for the exception.
HTTP Status Code: 500

 ** InvalidRequestException **   
The request is not valid.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** ServiceUnavailableException **   
The service is temporarily unavailable.    
 ** message **   
The message for the exception.
HTTP Status Code: 503

 ** ThrottlingException **   
The rate exceeds the limit.    
 ** message **   
The message for the exception.
HTTP Status Code: 400

 ** UnauthorizedException **   
You are not authorized to perform this operation.    
 ** message **   
The message for the exception.
HTTP Status Code: 401

## See Also
<a name="API_ListThingTypes_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/iot-2015-05-28/ListThingTypes) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/iot-2015-05-28/ListThingTypes) 